#include "extern.h"
#include "pouch.h"
#include "item.h"
#include <list>
#include <algorithm>

pouch::pouch()
{
  count = 0;
}

pouch::~pouch()
{
  clear();
}

void pouch::clear()
{
  items.clear();
}

bool pouch::isEmpty()
{
  return items.empty();
}

void pouch::sort()
{
  items.sort();
}

itemContainer *pouch::Find(int id)
{
  list<itemContainer>::iterator item_iter;
  item_iter = items.begin();

  while (item_iter != items.end())
    {
      if ((*item_iter).getItem()->getID() == id)
	{
	  return &(*item_iter);
	}
      ++item_iter;
    }
  return NULL;
}

itemContainer *pouch::Find(char *n)
{
  list<itemContainer>::iterator item_iter;
  item_iter = items.begin();

  while (item_iter != items.end())
    {
      if ((*item_iter).getItem()->getName() == n)
	{
	  return &(*item_iter);
	}
      ++item_iter;
    }
  return NULL;
}

itemContainer *pouch::Find(string &n)
{
  list<itemContainer>::iterator item_iter;
  item_iter = items.begin();
  
  while (item_iter != items.end())
    {
      if ((*item_iter).getItem()->getName() == n)
        {
          return &(*item_iter);
        }
      ++item_iter;
    }

  return NULL;
}

itemContainer *pouch::addItem(item *i)
{
  if (count >= 3000 || count >= maxitems)
    {
      return NULL;
    }
  itemContainer it(i), *temp;
  items.push_front(it);
  ++count;
  temp = &items.front();
  sort();
  return temp;
}

itemContainer *pouch::addItem(item *i, int amt)
{
  if (count >= 3000 || count + amt >= maxitems)
	{
	  return NULL;
	}

  itemContainer it(i), *temp;
  for (int x=0; x < amt; x++)
	{
	  items.push_front(it);
	  ++count;
	}
  temp = &items.front();
  sort();
  return temp;
}

itemContainer *pouch::addItemNoChecks(item *i)
{
  itemContainer it(i);
  items.push_front(it);
  ++count;
  return &items.front();
}

void pouch::deleteItem(item *i)
{
  list<itemContainer>::iterator item_iter;
  count--;
  
  item_iter = find(items.begin(), items.end(), i);
  
  if (item_iter != items.end())
    items.erase(item_iter);
}

const pouch &pouch::operator=(const pouch &right)
{
  if (&right != this)
    {
      items.clear();
      items = right.items;
    }
  return *this;
}
